#include <iostream>
#include <fstream>
using namespace std;

ifstream f("mugurita.in");
ofstream g("mugurita.out");

long long n, m, z, c, x, y;

/// Complexitate: O(log N)
pair < int, int > offsets[6] = {{-1, 2}, {-2, 0}, {-1, -2}, {1, -2}, {2, 0}, {1, 2}};

void solve_1() {
    f >> z;
    long long r = 1;
    long long st = 1, dr = 1e9, mij;
    while (st != dr) {
        mij = (st + dr) / 2;
        if (3 * (mij) * (mij + 1) < z) {
            st = mij + 1;
        }
        else dr = mij;
    }
    r = st;
    z -= 3 * (r) * (r-1);
    int a = 2 * r, b = 0, edge = 0;
    while (z) {
        a += min(r, z) * offsets[edge].first;
        b += min(r, z) * offsets[edge].second;
        z -= min(r, z);
        edge++;
    }
    g << a << " " << b;
}

void solve_2() {
    f >> x >> y;
    int a = (x + y/2) / 2, b = (y/2);
    long long r = max(abs(a), max(abs(b), abs(a - b)));
    long long z = 3 * (r) * (r - 1);
    a = 2 * r; b = 0;
    int edge = 0;
    if (a == x && b == y) z += 6*r;
    while (a != x || b != y) {
        if (offsets[edge].second != 0) {
            int oa = offsets[edge].first, ob = offsets[edge].second;
            if ((x-a)%oa == 0 && (y-b)%ob == 0 && (x-a)/oa == (y-b)/ob && (x-a)/oa >= 0 && (x-a)/oa <= r) {
                z += (x-a) / oa;
                a = x; b = y;
            }
            else {
                z += r;
                a += r * oa; b += r * ob;
            }
        }
        else {
            int oa = offsets[edge].first;
            if ((x-a)%oa == 0 && y == b && (x-a)/oa >= 0 && (x-a)/oa <= r) {
                z += (x-a) / oa;
                a = x; b = y;
            }
            else {
                z += r;
                a += r * oa; 
            }
        }
        edge++;
    }
    g << z;
}

int main() {
    f >> c;  
    if (c == 1) solve_1();
    else solve_2();
    return 0;
}